%% Bringing closer Debian and Rails
%% Bridging apparently incompatible cultures
%%
%% Abstract
%%
%% Ruby on Rails has become a very popular framework for Web-based
%% applications. And, even though Rails itself is neatly packaged and
%% integrated in Debian, supporting Rails applications (specially in a
%% large-scale provider) can prove rather difficult. Besides the core
%% application, we face problems such as handling plugins, concurrent
%% versions, and the like. In this BoF session we will try and study
%% the different problems we face, and come up with adequate
%% solutions.
%%
%% I'm only familiar with Ruby on Rails - but it might be interesting
%% to have the opinion of people working with other similar-minded
%% frameworks.
\documentclass{beamer}

\mode<presentation> {
  \usetheme{Darmstadt}
  \setbeamercovered{transparent}
}

\usepackage[spanish]{babel}
\usepackage[latin1]{inputenc}
\usepackage{pdfpages}
\usepackage{alltt}
\usepackage{verbatim}
\usepackage{hyperref}

\title[Debian + Rails]
      {Bringing closer Debian and Rails:\\
        Bridging apparently incompatible cultures} 

\author[Gunnar Wolf]{Gunnar Wolf --- {\tt gwolf@debian.org}
%%\url{http://www.gwolf.org/soft/debian+rails}}
}

%% \institute[IIEc - UNAM; Debian]
%% {Instituto de Investigaciones Econ\'omicas, UNAM\\
%% Desarrollador del proyecto Debian}

%%\date[ENLi 2007]{
%%  Encuentro Nacional de Linux y Software Libre\\
%%  Octubre 19, 2007
%%}
\date[DebConf 8]{
  DebConf 8\\
  August 2008, Mar del Plata, Argentina
}

\pgfdeclareimage[height=2cm]{debian-logo}{debian-swirl}
\logo{\pgfuseimage{debian-logo}}

\AtBeginSection[]
{
  \begin{frame}<beamer>
    \frametitle{Temas}
    \tableofcontents[currentsection]
  \end{frame}
}

% If you wish to uncover everything in a step-wise fashion, uncomment
% the following command: 
%\beamerdefaultoverlayspecification{<+->}

\begin{document}

\begin{frame}
  \titlepage
\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Gems}

\begin{frame}
  \frametitle {Gems}
  \begin{itemize}
  \item Ruby's own package management system
  \item Integrates the semantics of module inclusion and package
    downloading in one single, comfortable(?) step: {\tt require\_gem}
  \item One of its main points: Managing different installed versions
    of the same gem
  \end{itemize}
\end{frame}

\begin{frame}
  \frametitle {Gems}
  \begin{itemize}
  \item Way to easily installed unsupported (by Debian) third-party
    libs
  \item Source-intrusive we need to patch a gemified lib so that it
    works without rubygems
  \item Ignores non-rubygems packages when trying to satisfy deps
  \item Some ruby libs are only distributed as gems
  \item De-gemification of complex ruby apps is very complex
  \item Encourages strict deps on a specific versions: you end up with
    many versions installed
  \item Doesn't encourage stable APIs at all (people just install the
    latest upstream, then cry)
  \end{itemize}
\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Plugins}

\begin{frame}
  \frametitle {Plugins}
  \begin{itemize}
  \item Very similar to Gems-based modules, but more tightly
    integrated into Rails' workflow, modifying or adding to Rails'
    normal behaviour
  \item Usually carry an initialization file (init.rb), and require
    only being dropped in their place ({\tt
      RAILS\_ROOT/vendor/plugins/}); no need for explicitly including
    them.
  \end{itemize}
\end{frame}

\begin{frame}
  \frametitle {Plugins}
  \begin{itemize}
  \item Some plugins have started migrating to become Gems
  \item Some plugins... Completely despise the concept of {\em
    versions} --- The only way it is distributed is as a {\tt git
    clone} URL. And often, they don't even tag in their git trees!
  \end{itemize}
\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section[Vendorization]{Framework vendorization}

\begin{frame}
  \frametitle {Framework vendorization}
  \begin{itemize}
  \item Rails' API is still evolving at a fast speed --- often
    introducing backwards incompatibility
  \item It is common for application developers to {\em vendorize}
    Rails --- To copy a whole version of Rails into {\tt
      RAILS\_ROOT/vendor/rails}, in order to ensure his system will
    work regardless if the systemwide version changes
  \end{itemize}
\end{frame}

\begin{frame}
  \frametitle {Framework vendorization}
  \begin{itemize}
  \item In fact, when creating the skeleton for a new Rails app, the
    Debian-packaged Rails creates symlinks from {\tt
      RAILS\_ROOT/vendor/rails} to {\tt /usr/share/rails} (for the
    currently installed Rails). Of course, this leads to breakage on
    updates :-/
  \item Supporting Rails installed inside application directories is
    far from The Debian Way. And, of course, supporting multiple old
    versions of Rails in the system... is also bad.
  \end{itemize}
\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Deployment}

\begin{frame}
  \frametitle {Deployment}
  \begin{itemize}
  \item One of the most unstable areas in Rails 
  \item Favored deployment has went through Apache+Pen+FCGI,
    Apache+SCGI, {\em any\_web\_server}+Mongrel, Apache+mod\_rails
    (Passenger), and there is a newcomer somewhere around
    there... bah.
  \item Many people have complained about Rails' unfriendliness for
    deployment
  \end{itemize}
\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Rails appplications packaging}

\begin{frame}
  \frametitle {Rails applications packaging}
  \begin{itemize}
  \item No Rails applications are currently packaged for Debian... But
    there {\em will} be. At least, there {\em should} be.
  \item And all of the before mentioned points have to be integrated.
  \item We must aim for the best ease of deployment possible.
  \end{itemize}
\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section[Devel culture]{General developer community culture}

\begin{frame}
  \frametitle {General developer community culture}
  \begin{itemize}
  \item There is a big cultural difference between us Debianers and
    most of the Rails community
  \item  Rails developers tend to look for the newest features for their
    (production!) systems, and tend to value less long-term
    stability/maintainability. Interaction with upstream regarding
    older versions can be quite problematic
  \item Of course, I expect the previous statement to raise rushes of
    indignation among Rails (and other Extreme Programming converts),
    but... In Debian we commit to supporting our stable versions!
  \end{itemize}
\end{frame}

\end{document}
